<template>
  <div class="app-container">
    <el-row ref="listQueryContainer" class="query-container" justify="space-between" type="flex">
      <el-col>
        <el-form ref="listQuery" :inline="true" :model="listQuery" style="flex-wrap: wrap" @submit.native.prevent @keyup.enter.native="onSubmit">
          <el-form-item label="楼栋" prop="buildingName">
            <el-input v-model.trim="listQuery.buildingName" clearable maxlength="16" placeholder="请输入楼栋名称" @clear="listQuery.buildingName=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="楼层" prop="floorName">
            <el-input v-model.trim="listQuery.floorName" clearable maxlength="16" placeholder="请输入楼层名称" @clear="listQuery.floorName=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="房间" prop="roomName">
            <el-input v-model.trim="listQuery.roomName" clearable maxlength="16" placeholder="请输入房间名称" @clear="listQuery.roomName=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="设备" prop="name">
            <el-input v-model.trim="listQuery.name" clearable maxlength="16" placeholder="请输入设备名称" @clear="listQuery.name=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="类型" prop="type">
            <el-select v-model="listQuery.type" clearable placeholder="请选择设备类型" @change="onFilterChange" @clear="listQuery.type=undefined">
              <el-option v-for="item in typeList" :key="item.id" :label="item.label" :value="item.id"></el-option>
            </el-select>
          </el-form-item>

          <el-form-item label-width="0">
            <el-button type="primary" @click="onFilterChange">查询</el-button>
            <el-button plain type="primary" @click="resetFields">重置</el-button>
            <el-button plain type="primary" @click="onExport">导出</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <form-clear :shrinkable="shrinkable" @change="onExpansion" @clear="resetFields"/>
    </el-row>

    <el-row class="flex">
      <el-button type="primary" @click="fileDownload">模板下载</el-button>
      <el-upload
          accept=".xlsx"
          action=""
          class="ml10"
          :show-file-list="false"
          :http-request="fileUpload">
        <el-button type="primary">批量导入</el-button>
      </el-upload>
      <el-button type="primary" @click="onAdd" class="ml10">添加</el-button>
      <el-button v-if="!editing" plain type="primary" @click="onBatchDelete">批量删除</el-button>
      <el-button v-if="editing" :disabled="!(selectIds&&selectIds.length)" type="danger" @click="onDeleteSelect">删除
      </el-button>
      <el-button v-if="editing" plain @click="onCancel">取消</el-button>
    </el-row>

    <el-table ref="table" :data="list" border class="mt10" highlight-current-row stripe @sort-change="onSortChange"
              @selection-change="onTableSelectionChange" @row-click="onRowClick">
      <el-table-column v-if="editing" fixed type="selection" width="55"></el-table-column>
      <el-table-column :index="indexCompute" align="center" fixed="left" label="序号" type="index" width="60px"/>
      <el-table-column align="center" fixed="left" label="设备名称" min-width="110px" prop="name" sortable="custom"/>
      <el-table-column align="center" label="设备编号" prop="number" sortable="custom" width="110px"/>
      <el-table-column align="center" label="所属楼栋" min-width="110px" prop="buildingName" sortable="custom"/>
      <el-table-column align="center" label="所属楼层" min-width="110px" prop="floorName" sortable="custom"/>
      <el-table-column align="center" label="所属房间" min-width="110px" prop="roomName" sortable="custom"/>
      <el-table-column align="center" label="关联项目数" prop="checkItemTotal" sortable="custom" width="125px"/>
      <el-table-column align="center" label="设备类型" min-width="120px" prop="params" sortable="custom">
        <template v-slot="scope">
          <router-link v-if="scope.row.type===1" :to="{name:'DeviceDeviceCabinet',query:{id:scope.row.cabinet.id, layerCount:scope.row.cabinet.layerTotal }}">
            <el-link type="primary">机柜({{ scope.row.cabinet.layerUsed }}/{{ scope.row.cabinet.layerTotal }})</el-link>
          </router-link>
          <p v-else>其他</p>
        </template>
      </el-table-column>
      <el-table-column align="center" label="创建时间" prop="createTime" sortable="custom" width="160px">
        <template v-slot="scope">
          {{ scope.row.createTime | dateFormat }}
        </template>
      </el-table-column>
      <el-table-column align="center" label="操作" width="140px">
        <template v-slot="scope">
          <el-link icon="el-icon-edit" type="primary" @click="onUpdate(scope.row)">编辑</el-link>
          <el-link class="ml20" icon="el-icon-delete" type="danger" @click="onDelete(scope.row)">删除</el-link>
        </template>
      </el-table-column>
    </el-table>
    <pagination :page.sync="listQuery.page" :size.sync="listQuery.size" :total="total" @change="onPageChange"/>

    <el-dialog :close-on-click-modal="false" :close-on-press-escape="false" :visible.sync="exportVisible" title="导出" width="600px">
      <el-progress :percentage="exportProgress" :stroke-width="24" :text-inside="true" status="success"></el-progress>
      <el-button slot="footer" @click="onCancelExport">取 消</el-button>
    </el-dialog>

    <el-dialog :close-on-click-modal="false" :close-on-press-escape="false" :visible.sync="importVisible" title="正在导入" width="600px">
      <el-progress :percentage="importProgress" :stroke-width="24" :text-inside="true" status="success"></el-progress>
    </el-dialog>
  </div>
</template>

<script>
import {dateFormat} from "@/utils/dateUtil"
import {upload} from "@/utils/httpUtil";
import {saveAs} from 'file-saver'
import settings from '@/config'

export default {
  name: "DeviceDevice",
  data() {
    return {
      shrinkable: false, // 查询条件是否可以展开
      listQuery: { // 查询对象
        name: undefined, // 设备名称
        buildingName: undefined, // 楼栋名称
        buildingId: undefined, // 楼栋id
        floorNName: undefined, // 楼层名称
        floorId: undefined, // 楼层id
        roomName: undefined, // 房间名称
        roomId: undefined, // 房间id
        model: undefined, // 设备型号
        type: undefined, // 设备类型
        order: undefined,
        page: 1,
        size: 10
      },
      statusTimer: undefined, // 定时器
      list: [], // 结果列表
      total: 0, // 总结果数量

      exportVisible: false, // 是否显示导出对话框
      importVisible: false, // 是否显示导入对话框
      exportData: [], // 导出数据
      exportPagination: { // 导出分页
        page: 1,
        size: 500,
      },
      exportProgress: 0, // 导出进度
      importProgress: 0, // 导入进度
      exportCancel: false, // 是否取消导出

      editing: false, // 表格编辑中

      selectIds: undefined, // 选中多条记录的id

      typeList: [{id: 1, label: "机柜"}, {id: 99, label: "其他"}],
    }
  },

  watch: {},

  // 页面创建
  created() {
    this.initData();
    this.initEvent();
  },

  // 页面挂载
  mounted() {
    this.initQuery();
    this.getList();
    this.initView();
  },

  // keep-alive 显示界面时调用
  activated() {
    this.$refs["table"].doLayout();
    let buildingId = this.$route.params.buildingId && Number(this.$route.params.buildingId)
    let floorId = this.$route.params.floorId && Number(this.$route.params.floorId)
    let roomId = this.$route.params.roomId && Number(this.$route.params.roomId)
    if (buildingId || floorId || roomId) {
      this.listQuery.buildingId = buildingId;
      this.listQuery.floorId = floorId;
      this.listQuery.roomId = roomId;
      this.getList();
    }
  },

  // keep-alive 页面隐藏
  deactivated() {
  },

  methods: {
    // 初始化数据
    initData() {
    },

    // 初始化事件
    initEvent() {
      this.$eventBus.$on("DeviceDeviceAdd", this.onAddComplete);
      this.$eventBus.$on("DeviceDeviceUpdate", this.onUpdateComplete);
    },

    // 初始化查询条件
    initQuery() {
      if (this.$store.state.app.paramCache) {
        let query = this.$storage.getData(this.$options.name);
        if (Object.keys(query).length > 0) {
          this.listQuery = query;
          if (query.order) {
            this.$refs.table.sort(query.order.substring(1), query.order.substring(0, 1) === "+" ? "ascending" : "descending");
          } else {
            this.$refs.table.clearSort();
          }
        }
      }
    },

    // 初始化视图
    initView() {
      this.$nextTick(() => {
        this.shrinkable = this.$store.state.app.filterShrink && this.$refs['listQuery'].$el.offsetHeight > 51;
      })
    },

    // 展开/收起查询条件
    onExpansion(show) {
      this.$refs['listQueryContainer'].$el.style.height = show ? "auto" : "51px";
    },

    // 表格索引
    indexCompute(index) {
      return index + 1 + (this.listQuery.page - 1) * this.listQuery.size;
    },

    // 表单提交
    onSubmit() {
      this.onFilterChange();
    },

    // 表单清除
    resetFields() {
      this.$refs['listQuery'].resetFields();
      this.listQuery.buildingId = undefined;
      this.listQuery.floorId = undefined;
      this.listQuery.roomId = undefined;
      this.listQuery.order = undefined;
      this.$refs.table.clearSort();
      this.onFilterChange();
    },

    // 下载模板
    fileDownload() {
      // TODO 修改文件地址
      saveAs(settings.baseUrl.excel+'/device.xlsx')
      // saveAs('https://www.zwywpt.top/excel/device.xlsx')
    },

    // 上传文件
    fileUpload(request) {
      upload('/v1/device/import', request.file).then(url => {
        this.$message.success("文件上传成功，数据导入中");
        this.importProgress = 0;
        this.restartStatusTimer();
        this.importVisible = true;
      });
    },

    // 添加
    onAdd() {
      this.onCancel();
      this.$router.push({path: '/device/device/add'})
    },

    // 开始刷新状态
    restartStatusTimer() {
      this.stopStatusTimer();
      this.statusTimer = window.setInterval(this.progressRate, 1000);
    },

    // 停止刷新状态
    stopStatusTimer() {
      if (this.statusTimer) {
        window.clearInterval(this.statusTimer);
      }
      this.statusTimer = undefined;
    },

    // 获取文件处理进度
    progressRate() {
      this.$axios.get("/v1/device/import/progress/rate", undefined, false).then(data => {
        if (data.updating) {
          this.importProgress = Math.round(data.processCount * 100 / data.total);
        } else {
          if (data.message) {
            this.$message.error(data.message);
          } else {
            this.$message.success("导入完成");
          }
          this.stopStatusTimer();
          this.importVisible = false;
        }
      });
    },

    // 编辑
    onBatchDelete() {
      this.editing = true;
    },

    // 删除选中
    onDeleteSelect() {
      this.$confirm('此操作将永久删除选中的记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.$axios.delete('/v1/device/delete', {params: {ids: this.selectIds}}).then((data) => {
          if (this.list.length <= this.selectIds.length && this.listQuery.page > 1) {
            this.listQuery.page -= 1;
          }
          this.selectIds = undefined;
          if (data > 0) {
            this.$message.success("删除成功");
          } else {
            this.$message.warning("删除失败");
          }
          this.getList();
        });
      });
    },

    // 取消编辑
    onCancel() {
      this.$refs['table'].clearSelection();
      this.editing = false;
    },

    // 更新
    onUpdate(item) {
      this.$router.push({path: '/device/device/edit', query: {id: item.id}});
    },

    // 添加完成
    onAddComplete() {
      this.onFilterChange();
    },

    // 更新完成
    onUpdateComplete() {
      this.onFilterChange();
    },

    // 删除
    onDelete(item) {
      this.$confirm('此操作将永久删除该记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.$axios.delete(`/v1/device/delete/${item.id}`).then((data) => {
          if (this.list.length === 1 && this.listQuery.page > 1) {
            this.listQuery.page -= 1;
          }
          if (data > 0) {
            this.$message.success("删除成功");
          } else {
            this.$message.warning("删除失败");
          }
          this.getList();
        });
      });
    },

    // 数据选择
    onTableSelectionChange(val) {
      this.selectIds = val.map(item => item.id);
    },

    // 排序改变
    onSortChange({prop, order}) {
      if (order === "ascending") {
        this.listQuery.order = "+" + prop;
      } else if (order === "descending") {
        this.listQuery.order = "-" + prop;
      } else {
        this.listQuery.order = undefined;
      }
      this.onFilterChange();
    },

    // 行点击
    onRowClick(row, column, event) {
      this.$refs["table"].setCurrentRow(row);
      if (this.editing) {
        this.$refs["table"].toggleRowSelection(row);
      }
    },

    // 条件改变
    onFilterChange() {
      this.listQuery.page = 1;
      this.$nextTick(this.getList);
    },

    // 页码改变
    onPageChange() {
      this.getList();
    },

    // 加载列表
    getList() {
      // 缓存参数
      if (this.$store.state.app.paramCache) {
        this.$storage.setData(this.$options.name, this.listQuery);
      }

      this.$axios.get('/v1/device/list', {params: this.listQuery}).then(data => {
        this.list = data.list;
        this.total = data.total;
        this.$refs["table"].doLayout();
      });
    },

    // 导出数据
    onExport() {
      if (this.total > 0) {
        this.exportPagination.page = 1;
        this.exportData = [];
        this.exportVisible = true;
        this.getExportData();
      }
    },

    // 取消导出
    onCancelExport() {
      this.exportVisible = false;
      this.exportCancel = true;
    },

    // 获取数据并导出
    getExportData() {
      if (!this.exportCancel) {
        this.$axios.get('/v1/device/list', {params: {...this.listQuery, ...this.exportPagination}}).then(data => {
          this.exportPagination.page++;
          this.exportData = this.exportData.concat(data.list);
          this.exportProgress = Math.round(this.exportData.length * 100 / this.total);
          if (this.exportData.length < this.total && data.list.length > 0) {
            this.getExportData();
          } else {
            this.exportVisible = false;

            let tHeader = ["序号",
              "设备名称",
              "设备编号",
              "楼栋名称",
              "楼层名称",
              "房间名称",
              "关联项目数",
              "设备类型",
              "机柜已使用层数",
              "机柜总层数",
              "设备创建时间",
            ];
            let filterVal = ["index",
              "name",
              "number",
              "buildingName",
              "floorName",
              "roomName",
              "checkItemTotal",
              "type",
              "layerUsed",
              "layerTotal",
              "createTime",
            ];
            let data = this.exportData.map((value, index) => filterVal.map((key) => {
              if (key === "index") {
                return index + 1;
              } else if (key === "createTime") {
                return dateFormat("yyyy-MM-dd HH:mm:ss", value[key]);
              } else if (key === "type") {
                return this.typeList.find(item => item.id === value[key]).label;
              } else {
                return value[key];
              }
            }));
            import('@/utils/Export2Excel').then(excel => {
              excel.export_json_to_excel({
                header: tHeader, // 表头 必填
                data, // 具体数据 必填
                filename: '设备信息列表', // 非必填
                autoWidth: true, // 非必填
                bookType: 'xlsx' // 非必填
              })
            })
          }
        });
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.app-container {

}
</style>
